Project Chrono: chrono::ChHydraulicActuatorBase Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
chrono::ChHydraulicActuatorBase Class Referenceabstract

## Description

Base class for a hydraulic actuator.

All hydraulic actuators contain a cylinder and a directional valve. Derived classes may add additional components and combine these in circuits with different numbers of fluid (oil) volumes.

A hydraulic actuator can be attached between two bodies, in which case the actuator length and length rate of change is inferred from the states of those two bodies. Alternatively, a hydraulic actuator can be instantiated stand-alone (e.g., for use in a co-simulation setting), in which case the actuator length and rate must be provided from outside.

`#include <ChHydraulicActuator.h>`

Inheritance diagram for chrono::ChHydraulicActuatorBase:
[legend]
Collaboration diagram for chrono::ChHydraulicActuatorBase:
[legend]

## Public Member Functions
void | SetInputFunction (std::shared_ptr< ChFunction > fun)
| Set the actuation function.
void | SetPressures (double pump_pressure, double tank_pressure)
| Set the tank and pump pressures.
void | SetActuatorInitialLength (double len)
| Set actuator initial length [m].
void | SetInitialLoad (double F0)
| Set initial loading force.
void | Initialize ()
| Initialize the hydraulic actuator stand-alone.
void | Initialize (std::shared_ptr< ChBody > body1, std::shared_ptr< ChBody > body2, bool local, ChVector3d loc1, ChVector3d loc2)
| Initialize this hydraulic actuator by connecting it between the two specified bodies.
ChHydraulicCylinder & | Cylinder ()
| Access the hydraulic cylinder in this circuit.
ChHydraulicDirectionalValve4x3 & | DirectionalValve ()
| Access the directoinal valve in this circuit.
ChVector3d | GetPoint1Abs () const
| Get the endpoint location on 1st body (expressed in absolute coordinate system).
ChVector3d | GetPoint2Abs () const
| Get the endpoint location on 2nd body (expressed in body coordinate system).
void | SetActuatorLength (double len, double vel)
| Set the current actuator length and rate of change.
double | GetActuatorForce ()
| Get the current actuator force.
std::array< double, 2 > | GetCylinderPressures ()
| Get the current cylinder pressures.
double | GetValvePosition ()
| Get the current directional valve position.
Public Member Functions inherited from chrono::ChExternalDynamics
virtual ChExternalDynamics * | Clone () const override
| "Virtual" copy constructor (covariant return type).
void | Initialize ()
| Initialize the physics item.
ChVectorDynamic | GetInitialStates ()
| Get the initial values (state at initial time).
const ChVectorDynamic & | GetStates () const
| Get current states.
Public Member Functions inherited from chrono::ChPhysicsItem
| ChPhysicsItem (const ChPhysicsItem &other)
ChSystem * | GetSystem () const
| Get the pointer to the parent ChSystem().
virtual void | SetSystem (ChSystem *m_system)
| Set the pointer to the parent ChSystem().
void | AddVisualModel (std::shared_ptr< ChVisualModel > model)
| Add an (optional) visualization model.
std::shared_ptr< ChVisualModel > | GetVisualModel () const
| Access the visualization model (if any).
void | AddVisualShape (std::shared_ptr< ChVisualShape > shape, const ChFrame<> &frame=ChFrame<>())
| Add the specified visual shape to the visualization model.
std::shared_ptr< ChVisualShape > | GetVisualShape (unsigned int i) const
| Access the specified visualization shape in the visualization model (if any).
void | AddVisualShapeFEA (std::shared_ptr< ChVisualShapeFEA > shapeFEA)
| Add the specified FEA visualization object to the visualization model.
std::shared_ptr< ChVisualShapeFEA > | GetVisualShapeFEA (unsigned int i) const
| Access the specified FEA visualization object in the visualization model (if any).
virtual ChFrame | GetVisualModelFrame (unsigned int nclone=0) const
| Get the reference frame (expressed in and relative to the absolute frame) of the visual model.
virtual unsigned int | GetNumVisualModelClones () const
| Return the number of clones of the visual model associated with this physics item.
void | AddCamera (std::shared_ptr< ChCamera > camera)
| Attach a ChCamera to this physical item.
std::vector< std::shared_ptr< ChCamera > > | GetCameras () const
| Get the set of cameras attached to this physics item.
virtual bool | IsActive () const
| Return true if the object is active and included in dynamics.
virtual bool | IsCollisionEnabled () const
| Tell if the object is subject to collision.
virtual void | AddCollisionModelsToSystem (ChCollisionSystem *coll_sys) const
| Add to the provided collision system any collision models managed by this physics item.
virtual void | RemoveCollisionModelsFromSystem (ChCollisionSystem *coll_sys) const
| Remove from the provided collision system any collision models managed by this physics item.
virtual void | SyncCollisionModels ()
| Synchronize the position and bounding box of any collsion models managed by this physics item.
virtual ChAABB | GetTotalAABB ()
| Get the entire AABB axis-aligned bounding box of the object.
virtual void | GetCenter (ChVector3d &mcenter)
| Get a symbolic 'center' of the object.
virtual void | Setup ()
| This might recompute the number of coordinates, DOFs, constraints, in case this might change (ex in ChAssembly), as well as state offsets of contained items (ex in ChMesh).
virtual void | Update (bool update_assets=true)
| As above, but does not require updating of time-dependent data.
virtual void | ForceToRest ()
| Set zero speed (and zero accelerations) in state, without changing the position.
virtual unsigned int | GetNumCoordsVelLevel ()
| Get the number of coordinates at the velocity level.
virtual unsigned int | GetNumConstraints ()
| Get the number of scalar constraints.
virtual unsigned int | GetNumConstraintsBilateral ()
| Get the number of bilateral scalar constraints.
virtual unsigned int | GetNumConstraintsUnilateral ()
| Get the number of unilateral scalar constraints.
unsigned int | GetOffset_x ()
| Get offset in the state vector (position part).
unsigned int | GetOffset_w ()
| Get offset in the state vector (speed part).
unsigned int | GetOffset_L ()
| Get offset in the lagrangian multipliers.
void | SetOffset_x (const unsigned int moff)
| Set offset in the state vector (position part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_w (const unsigned int moff)
| Set offset in the state vector (speed part) Note: only the ChSystem::Setup function should use this.
void | SetOffset_L (const unsigned int moff)
| Set offset in the lagrangian multipliers Note: only the ChSystem::Setup function should use this.
virtual void | IntStateGatherReactions (const unsigned int off_L, ChVectorDynamic<> &L)
| From item's reaction forces to global reaction vector.
virtual void | IntStateScatterReactions (const unsigned int off_L, const ChVectorDynamic<> &L)
| From global reaction vector to item's reaction forces.
virtual void | IntStateIncrement (const unsigned int off_x, ChState &x_new, const ChState &x, const unsigned int off_v, const ChStateDelta &Dv)
| Computes x_new = x + Dt , using vectors at specified offsets.
virtual void | IntStateGetIncrement (const unsigned int off_x, const ChState &x_new, const ChState &x, const unsigned int off_v, ChStateDelta &Dv)
| Computes Dt = x_new - x, using vectors at specified offsets.
virtual void | IntLoadResidual_CqL (const unsigned int off_L, ChVectorDynamic<> &R, const ChVectorDynamic<> &L, const double c)
| Takes the term Cq'*L, scale and adds to R at given offset: R += c*Cq'*L.
virtual void | IntLoadConstraint_C (const unsigned int off, ChVectorDynamic<> &Qc, const double c, bool do_clamp, double recovery_clamp)
| Takes the term C, scale and adds to Qc at given offset: Qc += c*C.
virtual void | IntLoadConstraint_Ct (const unsigned int off, ChVectorDynamic<> &Qc, const double c)
| Takes the term Ct, scale and adds to Qc at given offset: Qc += c*Ct.
virtual void | InjectConstraints (ChSystemDescriptor &descriptor)
| Register with the given system descriptor any ChConstraint objects associated with this item.
virtual void | LoadConstraintJacobians ()
| Compute and load current Jacobians in encapsulated ChConstraint objects.
virtual void | ConstraintsBiReset ()
| Sets to zero the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_C (double factor=1, double recovery_clamp=0.1, bool do_clamp=false)
| Adds the current C (constraint violation) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Ct (double factor=1)
| Adds the current Ct (partial t-derivative, as in C_dt=0-> [Cq]*q_dt=-Ct) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsBiLoad_Qc (double factor=1)
| Adds the current Qc (the vector of C_dtdt=0 -> [Cq]*q_dtdt=Qc ) to the known term (b_i) of encapsulated ChConstraints.
virtual void | ConstraintsFetch_react (double factor=1)
| Fetches the reactions from the lagrangian multiplier (l_i) of encapsulated ChConstraints.
virtual void | ArchiveOut (ChArchiveOut &archive_out) override
| Method to allow serialization of transient data to archives.
virtual void | ArchiveIn (ChArchiveIn &archive_in) override
| Method to allow deserialization of transient data from archives.
Public Member Functions inherited from chrono::ChObj
| ChObj (const ChObj &other)
int | GetIdentifier () const
| Get the unique integer identifier of this object.
void | SetTag (int tag)
| Set an object integer tag (default: -1).
int | GetTag () const
| Get the tag of this object.
void | SetName (const std::string &myname)
| Set the name of this object.
const std::string & | GetName () const
| Get the name of this object.
double | GetChTime () const
| Gets the simulation time of this object.
void | SetChTime (double m_time)
| Sets the simulation time of this object.
virtual std::string & | ArchiveContainerName ()

## Protected Member Functions
virtual void | OnInitialize (const Vec2 &cyl_p0, const Vec2 &cyl_L0, double dvalve_U0)=0
| Process initial cylinder pressures and initial valve displacement.
virtual double | ExtractValveSpoolPosition () const =0
| Extract directional valve spool position from current state.
virtual Vec2 | ExtractCylinderPressures () const =0
| Extract cylinder pressures from current state.
double | GetInput (double t) const
| Get current actuator input.
virtual bool | IsStiff () const override
| Declare the EOM of this physics item as stiff or non-stiff.
virtual void | Update (double time, bool update_assets=true) override
| Update the physics item at current state.
virtual void | IntLoadResidual_F (const unsigned int off, ChVectorDynamic<> &R, const double c) override
| Load generalized forces.
Protected Member Functions inherited from chrono::ChExternalDynamics
virtual unsigned int | GetNumStates () const
| Specify number of states (dimension of y).
virtual void | SetInitialConditions (ChVectorDynamic<> &y0)
| Set initial conditions.
virtual void | CalculateRHS (double time, const ChVectorDynamic<> &y, ChVectorDynamic<> &rhs)
| Calculate and return the ODE right-hand side at the provided time and states.
virtual bool | CalculateJac (double time, const ChVectorDynamic<> &y, const ChVectorDynamic<> &rhs, ChMatrixDynamic<> &J)
| Calculate the Jacobian of the ODE right-hand side with respect to the ODE states.
virtual unsigned int | GetNumCoordsPosLevel () override
| Get the number of coordinates at the position level.
ChVariables & | Variables ()
virtual void | InjectVariables (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChVariable objects associated with this item.
virtual void | InjectKRMMatrices (ChSystemDescriptor &descriptor) override
| Register with the given system descriptor any ChKRMBlock objects associated with this item.
virtual void | IntStateGather (const unsigned int off_x, ChState &x, const unsigned int off_v, ChStateDelta &v, double &T) override
| From item's state to global state vectors y={x,v} pasting the states at the specified offsets.
virtual void | IntStateScatter (const unsigned int off_x, const ChState &x, const unsigned int off_v, const ChStateDelta &v, const double T, bool full_update) override
| From global state vectors y={x,v} to item's state (and update) fetching the states at the specified offsets.
virtual void | IntStateGatherAcceleration (const unsigned int off_a, ChStateDelta &a) override
| From item's state acceleration to global acceleration vector.
virtual void | IntStateScatterAcceleration (const unsigned int off_a, const ChStateDelta &a) override
| From global acceleration vector to item's state acceleration.
virtual void | IntLoadResidual_Mv (const unsigned int off, ChVectorDynamic<> &R, const ChVectorDynamic<> &v, const double c) override
| Takes the M*v term, multiplying mass by a vector, scale and adds to R at given offset: R += c*M*w.
virtual void | IntLoadLumpedMass_Md (const unsigned int off, ChVectorDynamic<> &Md, double &err, const double c) override
| Adds the lumped mass to a Md vector, representing a mass diagonal matrix.
virtual void | IntToDescriptor (const unsigned int off_v, const ChStateDelta &v, const ChVectorDynamic<> &R, const unsigned int off_L, const ChVectorDynamic<> &L, const ChVectorDynamic<> &Qc) override
| Prepare variables and constraints to accommodate a solution:
virtual void | IntFromDescriptor (const unsigned int off_v, ChStateDelta &v, const unsigned int off_L, ChVectorDynamic<> &L) override
| After a solver solution, fetch values from variables and constraints into vectors:
virtual void | LoadKRMMatrices (double Kfactor, double Rfactor, double Mfactor) override
| Compute and load current stiffnes (K), damping (R), and mass (M) matrices in encapsulated ChKRMBlock objects.
virtual void | VariablesFbReset () override
| Sets the 'fb' part (the known term) of the encapsulated ChVariables to zero.
virtual void | VariablesFbLoadForces (double factor=1) override
| Adds the current forces (applied to item) into the encapsulated ChVariables, in the 'fb' part: qf+=forces*factor.
virtual void | VariablesQbLoadSpeed () override
| Initialize the 'qb' part of the ChVariables with the current value of speeds.
virtual void | VariablesQbSetSpeed (double step=0) override
| Fetches the item speed (ex.
virtual void | VariablesFbIncrementMq () override
| Adds M*q (masses multiplied current 'qb') to Fb, ex.
virtual void | VariablesQbIncrementPosition (double step) override
| Increment item positions by the 'qb' part of the ChVariables, multiplied by a 'step' factor.
virtual void | ConstraintsFbLoadForces (double factor=1) override
| Adds the current link-forces, if any, (caused by springs, etc.) to the 'fb' vectors of the ChVariables referenced by encapsulated ChConstraints.
void | ComputeJac (double time)
| Compute the Jacobian at the current time and state.
Protected Member Functions inherited from chrono::ChObj
int | GenerateUniqueIdentifier ()

## Protected Attributes
bool | is_attached
| true if actuator attached to bodies
ChBody * | m_body1
| first conected body
ChBody * | m_body2
| second connected body
ChVector3d | m_loc1
| point on body 1 (local frame)
ChVector3d | m_loc2
| point on body 2 (local frame)
ChVector3d | m_aloc1
| point on body 1 (global frame)
ChVector3d | m_aloc2
| point on body 2 (global frame)
ChVectorDynamic | m_Qforce
| generalized forcing terms
ChHydraulicCylinder | cyl
| hydraulic cylinder
ChHydraulicDirectionalValve4x3 | dvalve
| directional valve
std::shared_ptr< ChFunction > | ref_fun
| actuation function (spool displacement reference)
double | s_0
| initial actuator length [m]
double | s
| current actuator length [m]
double | sd
| current actuator speed [m/s]
double | pP
| pump pressure [Pa]
double | pT
| tank pressure [Pa]
bool | calculate_consistent_IC
| solve initialization nonlinear system
double | F0
| estimated initial load
Protected Attributes inherited from chrono::ChPhysicsItem
ChSystem * | system
| parent system
std::shared_ptr< ChVisualModelInstance > | vis_model_instance
| instantiated visualization model
std::vector< std::shared_ptr< ChCamera > > | cameras
| set of cameras
unsigned int | offset_x
| offset in vector of state (position part)
unsigned int | offset_w
| offset in vector of state (speed part)
unsigned int | offset_L
| offset in vector of lagrangian multipliers
Protected Attributes inherited from chrono::ChObj
double | ChTime
| object simulation time
std::string | m_name
| object name
int | m_identifier
| object unique identifier
int | m_tag
| user-supplied tag

## Member Function Documentation

## ◆ GetActuatorForce()

double chrono::ChHydraulicActuatorBase::GetActuatorForce | ( |  | ) |

Get the current actuator force.

Can be used in a co-simulation interface.

## ◆ GetPoint1Abs()

ChVector3d chrono::ChHydraulicActuatorBase::GetPoint1Abs | ( |  | ) | const
| inline

Get the endpoint location on 1st body (expressed in absolute coordinate system).

Returns a zero location if the actuator is not attached to bodies.

## ◆ GetPoint2Abs()

ChVector3d chrono::ChHydraulicActuatorBase::GetPoint2Abs | ( |  | ) | const
| inline

Get the endpoint location on 2nd body (expressed in body coordinate system).

Returns a zero location if the actuator is not attached to bodies.

## ◆ Initialize() [1/2]

void chrono::ChHydraulicActuatorBase::Initialize | ( |  | ) |

Initialize the hydraulic actuator stand-alone.

In this case, actuator position and rate are supposed to be provided from the outside.

## ◆ Initialize() [2/2]

void chrono::ChHydraulicActuatorBase::Initialize | ( | std::shared_ptr< ChBody > | body1,
|  | std::shared_ptr< ChBody > | body2,
|  | bool | local,
|  | ChVector3d | loc1,
|  | ChVector3d | loc2 )

Initialize this hydraulic actuator by connecting it between the two specified bodies.

Parameters

  body1 | first connected body
  body2 | second connected body
  local | true if locations given in body local frames
  loc1 | location of connection point on body 1
  loc2 | location of connection point on body 2

## ◆ IntLoadResidual_F()

void chrono::ChHydraulicActuatorBase::IntLoadResidual_F | ( | const unsigned int | off,
|  | ChVectorDynamic<> & | R,
|  | const double | c )
| overrideprotectedvirtual

Load generalized forces.

Reimplemented from chrono::ChExternalDynamics.

## ◆ IsStiff()

virtual bool chrono::ChHydraulicActuatorBase::IsStiff | ( |  | ) | const
| inlineoverrideprotectedvirtual

Declare the EOM of this physics item as stiff or non-stiff.

Reimplemented from chrono::ChExternalDynamics.

## ◆ OnInitialize()

virtual void chrono::ChHydraulicActuatorBase::OnInitialize | ( | const Vec2 & | cyl_p0,
|  | const Vec2 & | cyl_L0,
|  | double | dvalve_U0 )
| protectedpure virtual

Process initial cylinder pressures and initial valve displacement.

Optionally, if the initial load F0 is provided, a derived class may calculate consistent initial conditions using the provided values as an initial guess.

## ◆ SetActuatorInitialLength()

void chrono::ChHydraulicActuatorBase::SetActuatorInitialLength | ( | double | len | ) |

Set actuator initial length [m].

This value is used only for an actuator not attached to bodies. For a connected actuator, the initial length is inferred from the initial body positions.

## ◆ SetActuatorLength()

void chrono::ChHydraulicActuatorBase::SetActuatorLength | ( | double | len,
|  | double | vel )

Set the current actuator length and rate of change.

Can be used in a co-simulation interface.

## ◆ SetInitialLoad()

void chrono::ChHydraulicActuatorBase::SetInitialLoad | ( | double | F0 | ) |

Set initial loading force.

If provided, this value is used in calculating consistent initial conditions, using the initial dircetional valve spool position and the initial cylinder pressures as initial guesses. Otherwise, the initial actuator state is set to the user specified values (which may be inconsistent with the configuration of the cylinder piston).

## ◆ SetInputFunction()

void chrono::ChHydraulicActuatorBase::SetInputFunction | ( | std::shared_ptr< ChFunction > | fun | ) |
| inline

Set the actuation function.

This function should return the directional valve input, normalized to the interval [-1,1]. The extreme values correspond to the maximum input voltage (providing full opening of the valve) to the proportional magnet controlling the valve spool position. Note that the provided input is automatically clamped to [-1,1].

## ◆ Update()

void chrono::ChHydraulicActuatorBase::Update | ( | double | time,
|  | bool | update_assets = true )
| overrideprotectedvirtual

Update the physics item at current state.

Reimplemented from chrono::ChExternalDynamics.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChHydraulicActuator.h
- D:/W/B/src/chrono-9.0.1/src/chrono/physics/ChHydraulicActuator.cpp